"""drop_column

Revision ID: 44cce443d2c0
Revises: 902a51ac4032
Create Date: 2023-07-23 13:47:04.111840

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "44cce443d2c0"
down_revision = "902a51ac4032"
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table(
        "nonebot_plugin_chatrecorder_messagerecord", schema=None
    ) as batch_op:
        batch_op.drop_column("bot_id")
        batch_op.drop_column("bot_type")
        batch_op.drop_column("platform")
        batch_op.drop_column("detail_type")
        batch_op.drop_column("user_id")
        batch_op.drop_column("group_id")
        batch_op.drop_column("guild_id")
        batch_op.drop_column("channel_id")

    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table(
        "nonebot_plugin_chatrecorder_messagerecord", schema=None
    ) as batch_op:
        batch_op.add_column(sa.Column("bot_id", sa.VARCHAR(length=64), nullable=False))
        batch_op.add_column(
            sa.Column("bot_type", sa.VARCHAR(length=64), nullable=False)
        )
        batch_op.add_column(
            sa.Column("platform", sa.VARCHAR(length=32), nullable=False)
        )
        batch_op.add_column(
            sa.Column("detail_type", sa.VARCHAR(length=32), nullable=False)
        )
        batch_op.add_column(sa.Column("user_id", sa.VARCHAR(length=64), nullable=False))
        batch_op.add_column(sa.Column("group_id", sa.VARCHAR(length=64), nullable=True))
        batch_op.add_column(sa.Column("guild_id", sa.VARCHAR(length=64), nullable=True))
        batch_op.add_column(
            sa.Column("channel_id", sa.VARCHAR(length=64), nullable=True)
        )

    # ### end Alembic commands ###
